Page MenuHomePhabricator

Add support for desktop notifications
Closed, ResolvedPublic

Tokens
"Like" token, awarded by monsdar."Manufacturing Defect?" token, awarded by seoker."Manufacturing Defect?" token, awarded by avivey."Like" token, awarded by benjumanji."Like" token, awarded by rbalik."Like" token, awarded by anton.vladimirov."Like" token, awarded by maroux."Like" token, awarded by nicereddy."Like" token, awarded by krisbuist.
Assigned To
Authored By
richardvanvelzen
Nov 20 2013, 9:12 PM

Description

Support Web Notifications for application notifications.

Major steps are likely to be:

  • Notifications require an enrollment step where the browser asks users to confirm that they want notifications.
    • Add SettingsDesktop Notifications and have that page check for enrollment and prompt the user to enroll.
    • This panel should also let users disable desktop notifications completely.
    • This panel should have a "Send test notification" button so users can confirm that notifications work and see what they look like.
  • If users are enrolled, we should emit application notifications as desktop notifications.
  • We may need to use JX.Leader to synchronize this (so multiple open tabs do not produce multiple identical notifications), or all browsers may be smart enough to deduplicate on their own.
  • We may need some additional preferences to control which application notifications promote into desktop notifications, but we'll probably have to build it and see how it feels first.

Event Timeline

richardvanvelzen raised the priority of this task from to Needs Triage.
richardvanvelzen updated the task description. (Show Details)
richardvanvelzen added a project: Phabricator.
richardvanvelzen added a subscriber: epriestley.
richardvanvelzen added a subscriber: richardvanvelzen.

Hey hey - here's some useful links on how to contribute good javascript --

http://www.phabricator.com/docs/phabricator/article/Contributor_Introduction.html
http://www.phabricator.com/docs/phabricator/article/General_Coding_Standards.html
http://www.phabricator.com/docs/phabricator/article/Javascript_Coding_Standards.html

That said, I wouldn't sweat things too much. Once you get to the arc diff stage you'll get all the feedback you can handle. :D

epriestley triaged this task as Wishlist priority.Apr 24 2014, 1:02 PM
epriestley removed a project: Phabricator.

Also interested in this. It could maaaybe reduce reliance on email </wishful thinking>

hach-que edited this Maniphest Task.Jun 14 2014, 4:44 AM
Zolli added a subscriber: Zolli.Jan 5 2015, 10:03 AM

Diff that very hackily implements desktop notifications on top of standard notifications: https://secure.phabricator.com/differential/diff/27013/

J5lx added a subscriber: J5lx.Jan 14 2015, 5:33 PM
rbalik added a subscriber: rbalik.
epriestley updated the task description. (Show Details)Mar 16 2015, 8:01 PM
benjumanji added a subscriber: benjumanji.

Very interested in this. Willing to contribute code if someone will have time to look at the patch (it doesn't have to be accepted, I just want to know that I am not stepping into something that is unlikely to get merged any time soon).

chad added a subscriber: chad.Apr 2 2015, 8:02 PM

I'd be happy to play with your patch.

Thanks, I'll get on it.

btrahan claimed this task.Jun 2 2015, 4:56 PM

Yoinking this. If you've made any progress on this, feel free to post a diff, otherwise I'm on it.

avivey added a subscriber: avivey.
avivey removed a subscriber: avivey.
seoker added a subscriber: seoker.
gerx03 added a subscriber: gerx03.May 19 2016, 11:02 AM
This comment was removed by ollehar.